﻿
function geosphere( radius , segs ) {

	var nsections:Number = 20;
	var subrad:Number, subz:Number, theta:Number, sn:Number, cs:Number , i:Number , f:Number;
	var nfaces:Number = nsections * segs * segs;
	var nverts:Number = nfaces / 2 + 2;

	function dot_product3d( v, w ) {
		return ( v[0] * w[0] ) + ( v[1] * w[1] ) + ( v[2] * w[2] );
	}

	// SphericalInterpolate //
	function interpolate( v1 , v2 , num ) {
		if ( segs < 2 ) return;
		var a = pts[ v1 ], b = pts[ v2 ];
		var rad = dot_product3d ( a , a );
		var cs = dot_product3d ( a , b ) / rad;
		cs = ( cs < -1 ) ? -1 : ( cs > 1 ) ? 1 : cs;
		var theta = Math.acos ( cs );
		var sn = Math.sin ( theta );
		for ( var e = 1 ; e <= num - 1 ; e++ ) {
			var np:Array = new Array();
			var theta1 = ( theta * e ) / num;
			var theta2 = ( theta * ( num - e ) ) / num;
			var st1 = Math.sin ( theta1 );
			var st2 = Math.sin ( theta2 );
			np[0] = ( a[0] * st2 + b[0] * st1 ) / sn;
			np[1] = ( a[1] * st2 + b[1] * st1 ) / sn;
			np[2] = ( a[2] * st2 + b[2] * st1 ) / sn;
			pts[ pts.length ] = np;
		}
	}
	
	// func to find vertices for trianngles //
	function findVertices( s , f , r , c ) {
		if ( r == 0 ) {
			if ( f <  5 ) return 0;
			if ( f > 14 ) return 11;
			return f - 4;
		}
		if ( r == s && c == 0 ) {
			if ( f <  5 ) return f + 1;
			if ( f < 10 ) return ( ( f + 4 ) % 5 ) + 6;
			if ( f < 15 ) return ( ( f + 1 ) % 5 ) + 1;
			return ( ( f + 1 ) % 5 ) + 6;
		}
		if ( r == s && c == s ) {
			if ( f <  5 ) return ( ( f + 1 ) % 5 ) + 1;
			if ( f < 10 ) return f + 1;
			if ( f < 15 ) return f - 9;
			return f - 9;
		}
		if ( r == s ) {
			if ( f <  5 ) return 12 + ( 5 + f ) * ( s - 1 ) + c-1;
			if ( f < 10 ) return 12 + ( 20 + ( ( f + 4 ) % 5 ) ) * ( s - 1 ) + c - 1;
			if ( f < 15 ) return 12 + ( f - 5 ) * ( s - 1 ) + s - 1 - c;
			return 12 + ( 5 + f ) * ( s - 1 ) + s - 1 - c;
		}
		if ( c == 0 ) {
			if ( f <  5 ) return 12 + f * ( s - 1 ) + r - 1;
			if ( f < 10 ) return 12 + ( ( f % 5 ) + 15 ) * ( s - 1 ) + r - 1;
			if ( f < 15 ) return 12 + ( ( ( f + 1 ) % 5 ) + 15 ) * ( s - 1 ) + s - 1 - r;
			return 12 + ( ( ( f + 1 ) % 5 ) + 25 ) * ( s - 1 ) + r - 1;
		}
		if ( c == r ) {
			if ( f <  5 ) return 12 + ( ( f + 1 ) % 5 ) * ( s - 1 ) + r - 1;
			if ( f < 10 ) return 12 + ( ( f % 5 ) + 10 ) * ( s - 1 ) + r - 1;
			if ( f < 15 ) return 12 + ( ( f % 5 ) + 10 ) * ( s - 1 ) + s - 1 - r;
			return 12 + ( ( f % 5 ) + 25 ) * ( s - 1 ) + r - 1;
		}
		return 12 + 30 * ( s - 1 ) + f * ( s - 1 ) * ( s - 2 ) / 2 + ( r - 1 ) * ( r - 2 ) / 2 + c - 1;
	}

	
	// ----------------------------------------------- //
	var pts:Array=new Array();
	var planes:Array=new Array();
	// get first 12 Vertices //
	pts[0] = [0 , 0 , radius];
	subz = Math.sqrt(0.2)*radius;
	subrad = 2*subz;
	for (i=0; i<5; i++) {
		theta = 2*Math.PI*i/5;
		sn = Math.sin(theta);
		cs = Math.cos(theta);
		pts.push([subrad*cs , subrad*sn , subz]);
	}

	for (i=0; i<5; i++) {
		theta = Math.PI*(2*i+1)/5;
		sn = Math.sin(theta);
		cs = Math.cos(theta);
		pts.push([subrad*cs , subrad*sn , -subz]);
	}

	pts.push([0 , 0 , -radius]);
//	for (i=0; i<12; i++) { pts[i].first = true };
	var nv = 11;
	// tessilate triangles //
	for (i=0; i<5; i++) interpolate ( 0 , i+1 , segs );
	for (i=0; i<5; i++) interpolate ( i+1 , (i+1)%5+1 , segs);
	for (i=0; i<5; i++) interpolate ( i+1 , i+6 , segs );
	for (i=0; i<5; i++) interpolate ( i+1 , (i+4)%5+6 , segs );
	for (i=0; i<5; i++) interpolate ( i+6 , (i+1)%5+6 , segs );
	for (i=0; i<5; i++) interpolate ( 11 , i+6 , segs );
	for (f=0; f<5; f++){
		for (i=1; i<=segs-2; i++) {
			interpolate ( 12 + f * ( segs - 1 ) + i , 12 + ( ( f + 1 ) % 5 ) * ( segs - 1 ) + i  , i + 1 );
		}
	}
	for (f=0; f<5; f++) {
		for (i=1; i<=segs-2; i++) {
			interpolate ( 12 + ( f + 15 ) * ( segs - 1 ) + i , 12 + ( f + 10 ) * ( segs - 1 ) + i  , i + 1 );
		}
	}
	for (f=0; f<5; f++) {
		for (i=1; i<=segs-2; i++) {
			interpolate ( 12 + ( ( ( f + 1 ) % 5 ) + 15 ) * ( segs - 1 ) + segs - 2 - i , 12 + ( f + 10 ) * ( segs - 1 ) + segs - 2 - i  , i + 1 );
		}
	}
	for (f=0; f<5; f++) {
		for (i=1; i<=segs-2; i++) {
			interpolate ( 12 + ( ( ( f + 1 ) % 5 ) + 25 ) * ( segs - 1 ) + i , 12 + ( f + 25 ) * ( segs - 1 ) + i , i + 1 );
		}
	}
	// create faces //
	var num=0;
	for (f=0; f<=nsections-1; f++) {
		for (var row:Number = 0 ; row <= segs - 1 ; row++ ) {
			for (var column:Number = 0 ; column <= row ; column++ ) {
				var a:Object = findVertices ( segs , f , row , column );
				var b:Object = findVertices ( segs , f , row + 1 , column );
				var c:Object = findVertices ( segs , f , row + 1 , column + 1 );
				planes[num++] = [ a , b , c ];
				if ( column < row ) {
					var d:Object = findVertices ( segs , f , row , column + 1 );
					planes[num++] = [ a , c , d  ];
	}	}	}	}
	
	vertices += pts.length;
	tris_max += planes.length;
	
	//find points for springs
	//=find the 6 nearest vertex points that are closest to the current
	//BETTER: search planes for the 6 occurrencies of the current point

	//nachher wenn man einen punkt anfasst, darf zu dessen Kraft nicht 
	//noch zusätzlich addiert werden, denn man die anderen punkte durchgeht

	var springs:Array=new Array();
	//var found_vertex_ids:Number=0;
	
	for (var n=0; n<pts.length; n++){			//for each vertex
		var fids:Array=[];	//found_vertex_ids
		for (var m=0; m<planes.length; m++){	//for each poly
			//if (planes[m][0]==n || planes[m][1]==n || planes[m][2]==n) trace(planes[m]);	//found a polygone which the current vertex is part of
			if (planes[m][0]==n) {array_push2(fids,planes[m][1]); array_push2(fids,planes[m][2]);}
			if (planes[m][1]==n) {array_push2(fids,planes[m][2]); array_push2(fids,planes[m][0]);}
			if (planes[m][2]==n) {array_push2(fids,planes[m][0]); array_push2(fids,planes[m][1]);}
		}
		springs[n]=fids;
	}

	
	//springs returns an array of 6 vertices for each vertex id
	//like: pts[5] is the vertex, then springs[5] are the 6 vertices around
	
	//return [pts,planes,springs];
	var tempa:Array=new Array();
	tempa["points"]=pts;
	tempa["polys"]=planes;
	tempa["springs"]=springs;
	//tempa.push( {points:pts , polys:planes , springs:springs } );
	//return tempa[0];
	//return( {points:pts , polys:planes , springs:springs } );
	return tempa;
}



function array_push2(array,element){	//adds element if its not in array yet
	for (var el in array){
		if (array[el]==element) return;
	}
	array.push(element);
}


/*
pts.push ( { x: subrad * cs , y: subrad * sn , z: subz } );
*/
